--------------------------------------------------------------------------
-- GTFO_Spells_LGN.lua 
--------------------------------------------------------------------------
--[[
GTFO Spell List - Legion
Author: Zensunim of Malygos
]]--

--- ********************
--- * The Broken Isles *
--- ********************

GTFO.SpellID["226512"] = {
  --desc = "Sanguine Ichor (Mythic+ Keystone)";
  sound = 1;
};

GTFO.SpellID["203114"] = {
  --desc = "Twilight Whirl (Twilight Bladetwister)";
  sound = 1;
};

GTFO.SpellID["193009"] = {
  --desc = "The Jailer's Prison (Niskaran Executioner)";
  applicationOnly = true;
  sound = 1;
};

GTFO.SpellID["206702"] = {
  --desc = "Choking Fog";
  sound = 1;
};

GTFO.SpellID["219044"] = {
  --desc = "Ennervating Field (Senegos Drawing)";
  applicationOnly = true;
  sound = 2;
};

GTFO.SpellID["208069"] = {
  --desc = "Arrow Barrage (Nathanos Blightcaller)";
  sound = 1;
  tankSound = 2;
};

GTFO.SpellID["190364"] = {
  --desc = "Plague-Dipped Arrows (Nathanos Blightcaller)";
  sound = 1;
};

GTFO.SpellID["180675"] = {
  --desc = "Guardian Gaze (Vault Guardian)";
  sound = 1;
};

GTFO.SpellID["195824"] = {
  --desc = "Lightforged Defense Matrix (Yotnar)";
  sound = 1;
};

GTFO.SpellID["187117"] = {
  --desc = "Static Charge";
  sound = 1;
};

GTFO.SpellID["193907"] = {
  --desc = "Fel Winds (Fel Commander Igrius)";
  sound = 1;
};

GTFO.SpellID["202809"] = {
  --desc = "Fury of the Illidari (Varedis Felsoul)";
  sound = 1;
};

GTFO.SpellID["192754"] = {
  --desc = "Nightmare Breath (Ysera)";
  sound = 1;
};

GTFO.SpellID["220053"] = {
  --desc = "Conductive Charge (Akama)";
  sound = 1;
};

GTFO.SpellID["215604"] = {
  --desc = "Dragon's Breath (Vision of Deathwing)";
  sound = 1;
};

GTFO.SpellID["191187"] = {
  --desc = "Storm Nova (Swirling Storms)";
  sound = 2;
};

GTFO.SpellID["212203"] = {
  --desc = "Fusion Press (Mimiron)";
  sound = 1;
};

GTFO.SpellID["212016"] = {
  --desc = "Lightning Bolt (Prustaga)";
  sound = 1;
};

GTFO.SpellID["190620"] = {
  --desc = "Felblaze Orb (Fel Orb)";
  sound = 2;
  tankSound = 0;
};

GTFO.SpellID["182815"] = {
  --desc = "Stoneblood Poison (Stoneblood Elderwitch)";
  applicationOnly = true;
	minimumStacks = 1;
	sound = 1;
};

GTFO.SpellID["186227"] = {
  --desc = "Raging Fire (Heathrow House)";
  sound = 1;
};

GTFO.SpellID["186237"] = {
  --desc = "Raging Fire (Heathrow House)";
  sound = 1;
};

GTFO.SpellID["215707"] = {
  --desc = "Burning (Tenpak Flametotem)";
  sound = 1;
};

GTFO.SpellID["214421"] = {
  --desc = "Searing Gaze (Inquisitor Tivos)";
  sound = 1;
};

GTFO.SpellID["222136"] = {
  --desc = "Corrosive Maw";
  sound = 1;
};

GTFO.SpellID["218866"] = {
  --desc = "Plagued Ground";
  sound = 1;
};

GTFO.SpellID["210584"] = {
  --desc = "Holy Ground";
  sound = 1;
};

GTFO.SpellID["219859"] = {
  --desc = "Claw Flurry (Bahagar)";
  sound = 1;
};

GTFO.SpellID["216498"] = {
  --desc = "Energy Smash (Orbyth)";
  sound = 1;
};

GTFO.SpellID["216495"] = {
  --desc = "Energy Smash (Orbyth)";
  sound = 1;
};

GTFO.SpellID["208639"] = {
  --desc = "Echo (Nameless King)";
  sound = 1;
};

GTFO.SpellID["219173"] = {
  --desc = "Echo (Nameless King)";
  sound = 1;
};

GTFO.SpellID["211022"] = {
  --desc = "Echo (Nameless King)";
  sound = 1;
};

GTFO.SpellID["219177"] = {
  --desc = "Echo (Nameless King)";
  sound = 1;
};

GTFO.SpellID["217529"] = {
  --desc = "Overflowing Taint (Infernal Lord)";
  sound = 1;
};

GTFO.SpellID["216149"] = {
  --desc = "Barrage (Huntress Estrid)";
  sound = 1;
};

GTFO.SpellID["219120"] = {
  --desc = "Doomfire (Archimonde)";
  sound = 1;
};

GTFO.SpellID["214491"] = {
  --desc = "Hindering Anomaly";
  sound = 1;
};

GTFO.SpellID["214123"] = {
  --desc = "Translocate Field (Arcavellus)";
  sound = 1;
};

GTFO.SpellID["225682"] = {
  --desc = "Furious Swipes (Bahagar)";
  sound = 1;
};

GTFO.SpellID["215717"] = {
  --desc = "Murky Secretion (Congealed Corruption)";
  sound = 1;
};

GTFO.SpellID["155865"] = {
  --desc = "Ravaging Whirl (Urgev the Flayer)";
  sound = 1;
};

GTFO.SpellID["220478"] = {
  --desc = "Boil Back (Boilback Bristlefur)";
  sound = 1;
  damageMinimum = 1;
};

GTFO.SpellID["204478"] = {
  --desc = "Spray Plague (Forsaken Plaguebringer)";
  sound = 1;
};

GTFO.SpellID["206564"] = {
  --desc = "Fel Storm (Eredar Portal-Lord)";
  sound = 1;
};

GTFO.SpellID["202544"] = {
  --desc = "Burning Rush (Herald Xarbizuld)";
  sound = 1;
};

GTFO.SpellID["169002"] = {
  --desc = "Torrent of Blades (Legion Battlematron)";
  sound = 1;
  tankSound = 0;
};

GTFO.SpellID["206777"] = {
  --desc = "Nightmare Void";
  applicationOnly = true;
  sound = 1;
};

GTFO.SpellID["209008"] = {
  --desc = "Fel Firestorm (Destromath)";
  sound = 1;
};

GTFO.SpellID["199568"] = {
  --desc = "Grasping Spirits";
  sound = 1;
};

GTFO.SpellID["201832"] = {
  --desc = "Fel Immolation (Ariden)";
  sound = 1;
};

-- **********
-- * Mardum *
-- **********

GTFO.SpellID["194811"] = {
	--desc = "Fel Beam";
	sound = 2;
};

GTFO.SpellID["200511"] = {
	--desc = "Anguished Soul (Anguish Jailer)";
	sound = 1;
};

GTFO.SpellID["195054"] = {
	--desc = "Beaming Gaze (Inquisitor Baleful)";
	sound = 1;
};

GTFO.SpellID["195401"] = {
	--desc = "Shadow Blaze (Doom Commander Beliash)";
	sound = 1;
};

GTFO.SpellID["192603"] = {
	--desc = "Spire of Woe (Doom Commander Beliash)";
	sound = 1;
};

GTFO.SpellID["197747"] = {
	--desc = "Fel Burning (General Volroth)";
	sound = 1;
};

GTFO.SpellID["197243"] = {
  --desc = "Gaseous Cloud (Prolifica)";
  sound = 1;
};

GTFO.SpellID["197609"] = {
  --desc = "Demon's Blood (Brood Queen Tyranna)";
  sound = 1;
};

-- ************************
-- * Vault of the Wardens *
-- ************************

GTFO.SpellID["201037"] = {
  --desc = "Seeping Shadows (Kethrazor)";
  sound = 1;
};

GTFO.SpellID["196502"] = {
  --desc = "Lingering Gaze (Glazer)";
  sound = 2;
};

GTFO.SpellID["191853"] = {
  --desc = "Furious Flames (Tirathon Saltheril)";
  sound = 1;
};

-- ********************
-- * The Broken Shore *
-- ********************


GTFO.SpellID["211195"] = {
  --desc = "Burn (Captain Naranoth)";
  sound = 1;
};

GTFO.SpellID["183623"] = {
  --desc = "Felsoul Inferno";
  sound = 1;
};

GTFO.SpellID["222588"] = {
  --desc = "Fel Immolation (Infernal Siegebreaker)";
  sound = 1;
};

GTFO.SpellID["183737"] = {
  --desc = "Felblaze (Felblaze Infernal)";
  sound = 1;
};



-- *********************
-- * Darkheart Thicket *
-- *********************

GTFO.SpellID["198408"] = {
  --desc = "Nightfall (Archdruid Glaidalis)";
  sound = 1;
};

GTFO.SpellID["218759"] = {
  --desc = "Corruption Pool (Festerhide Grizzly)";
  sound = 1;
};

GTFO.SpellID["191326"] = {
  --desc = "Breath of Corruption (Dresaron)";
  sound = 1;
  test = true;
};

GTFO.SpellID["199460"] = {
  --desc = "Falling Rocks (Dresaron)";
  sound = 1;
};

GTFO.SpellID["204976"] = {
  --desc = "Noxious Spit (Kudzilla)";
  sound = 1;
};



-- ******************
-- * Eye of Azshara *
-- ******************

GTFO.SpellID["196871"] = {
  --desc = "Storm (Hatecoil Stormweaver)";
  sound = 1;
};

GTFO.SpellID["192053"] = {
  --desc = "Quicksand (Warlord Parjesh)";
  sound = 1;
};

GTFO.SpellID["199948"] = {
  --desc = "Tempest (Channeler Varisz)";
  sound = 1;
};

GTFO.SpellID["195473"] = {
  --desc = "Abrasive Slime (Gritslime Snail)";
  sound = 1;
  applicationOnly = true;
};

GTFO.SpellID["191858"] = {
  --desc = "Toxic Puddle (Serpentrix)";
  sound = 1;
};

GTFO.SpellID["193055"] = {
  --desc = "Call the Seas (Call the Seas)";
  sound = 1;
  negatingBuffSpellID = 193018; -- Gaseous Bubbles
};

-- *********************
-- * Neltharion's Lair *
-- *********************

GTFO.SpellID["183407"] = {
  --desc = "Acid Splatter";
  soundFunction = function() -- Warn only on multiple hits to keep it from being too spammy
		if (GTFO_FindEvent("AcidSplatter")) then
			return 1;
		end
		GTFO_AddEvent("AcidSplatter", 1);
		return 0;
	end
};

GTFO.SpellID["192800"] = {
  --desc = "Choking Dust (Rokmora)";
  sound = 1;
  damageMinimum = 1;
};

GTFO.SpellID["183566"] = {
  --desc = "Rancid Pool (Tarspitter Lurker)";
  sound = 1;
};

GTFO.SpellID["186576"] = {
  --desc = "Petrifying Cloud";
  applicationOnly = true;
  sound = 1;
  test = true; -- Doesn't appear to be restricted to application only for some reason
};

GTFO.SpellID["188494"] = {
  --desc = "Rancid Maw (Naraxas)";
  applicationOnly = true;
  sound = 1;
};

GTFO.SpellID["226388"] = {
  --desc = "Rancid Ooze";
  sound = 1;
};

GTFO.SpellID["188493"] = {
  --desc = "Rancid Maw (Naraxas)";
  sound = 1;
};

GTFO.SpellID["210166"] = {
  --desc = "Toxic Wretch (Naraxas)";
  sound = 1;
};

GTFO.SpellID["217090"] = {
  --desc = "Magma Wave (Dargrul)";
  sound = 1;
};

-- *************
-- * The Nexus *
-- *************

GTFO.SpellID["209848"] = {
  --desc = "Icicle Barrage (Scion of Ice)";
  sound = 1;
};

GTFO.SpellID["207556"] = {
  --desc = "Heated Ground";
  sound = 1;
};

GTFO.SpellID["209839"] = {
  --desc = "Burning Diffusion (Diffusion)";
  sound = 1;
};

-- ******************
-- * Halls of Valor *
-- ******************

GTFO.SpellID["198903"] = {
  --desc = "Crackling Storm (Storm Drake)";
  sound = 1;
};

GTFO.SpellID["193234"] = {
  --desc = "Dancing Blade (Hymdall)";
  sound = 1;
};

GTFO.SpellID["199818"] = {
  --desc = "Crackle (Valarjar Thundercaller)";
  sound = 1;
};

GTFO.SpellID["200682"] = {
  --desc = "Eye of the Storm (Solsten)";
  sound = 1;
  negatingDebuffSpellID = 203963; -- Eye of the Storm
};

GTFO.SpellID["193702"] = {
  --desc = "Infernal Flames (God-King Skovald)";
  sound = 1;
};

GTFO.SpellID["193827"] = {
  --desc = "Ragnarok (God-King Skovald)";
  sound = 1;
};

-- *******************
-- * The Violet Hold *
-- *******************

GTFO.SpellID["205014"] = {
  --desc = "Seeping Shadows (Lord Malgath)";
  sound = 1;
};

GTFO.SpellID["205014"] = {
  --desc = "Frost Breath (Shivermaw)";
  sound = 1;
  tankSound = 0;
  applicationOnly = true;
};

GTFO.SpellID["201957"] = {
  --desc = "Frostbite (Shivermaw)";
  sound = 1;
};

GTFO.SpellID["204762"] = {
  --desc = "Violent Fel Energy (Portal Keeper)";
  sound = 1;
};

GTFO.SpellID["202266"] = {
  --desc = "Icky Goo (Festerface)";
  sound = 1;
};



-- **************
-- * The Arcway *
-- **************

-- TODO: Suppression Protocol (Corstilax)
-- TODO: Force Nova (Advisor Vandros)
-- TODO: Unstable Mana (Advisor Vandros) - FF when not the target

GTFO.SpellID["194006"] = {
  --desc = "Ooze Puddle (Unstable Amalgamation)";
  sound = 1;
};

GTFO.SpellID["200040"] = {
  --desc = "Nether Venom (Nal'tira)";
  sound = 1;
};

GTFO.SpellID["199812"] = {
  --desc = "Blink Strikes (Nal'tira)";
  sound = 1;
};

GTFO.SpellID["210750"] = {
  --desc = "Collapsing Rift (Withered Manawraith)";
  sound = 1;
};

GTFO.SpellID["220500"] = {
  --desc = "Destabilized Orb (Corstilax)";
  sound = 1;
};

GTFO.SpellID["211209"] = {
  --desc = "Arcane Slicer (Arcane Anomaly)";
  sound = 1;
};

GTFO.SpellID["196824"] = {
  --desc = "Nether Link (Ivanyr)";
  sound = 1;
};

GTFO.SpellID["220597"] = {
  --desc = "Charged Bolt (Ivanyr)";
  sound = 1;
};

GTFO.SpellID["211745"] = {
  --desc = "Fel Strike (Wrathguard Felblade)";
  sound = 1;
};

GTFO.SpellID["220443"] = {
  --desc = "Wake of Shadows (General Xakal)";
  sound = 1;
};


-- ****************
-- * Maw of Souls *
-- ****************

GTFO.SpellID["216107"] = {
  --desc = "Convulsive Shadows (Shroudseeker)";
  sound = 1;
};

GTFO.SpellID["194102"] = {
  --desc = "Poisonous Sludge (The Grimewalker)";
  sound = 1;
};

GTFO.SpellID["195035"] = {
  --desc = "Defiant Strike - Charge (Seacursed Soulkeeper)";
  sound = 1;
};

GTFO.SpellID["194235"] = {
  --desc = "Nether Rip (Harbaron)";
  sound = 1;
};

GTFO.SpellID["227234"] = {
  --desc = "Corrupted Bellow (Helya)";
  sound = 1;
};

-- ******************
-- * Court of Stars *
-- ******************

GTFO.SpellID["207278"] = {
	--desc = "Arcane Lockdown (Patrol Captain Gerdo)";
	test = true;
	alwaysAlert = true;
	soundFunction = function() 
		-- Alert if hit more than 3 times
		if (not GTFO.VariableStore.ArcaneLockdownHitCount) then
			GTFO.VariableStore.ArcaneLockdownHitCount = 0;
			GTFO.VariableStore.ArcaneLockdownStackCount = 0;
		end
		GTFO_AddEvent("ResetArcaneLockdownCounter", 5, function() GTFO.VariableStore.ArcaneLockdownHitCount = 0; GTFO.VariableStore.ArcaneLockdownStackCount = 0; end);
		GTFO.VariableStore.ArcaneLockdownHitCount = GTFO.VariableStore.ArcaneLockdownHitCount + 1;
		local stackCount = GTFO_DebuffStackCount("player", 207278);
		if (GTFO.VariableStore.ArcaneLockdownStackCount == stackCount) then
			if (GTFO.VariableStore.ArcaneLockdownHitCount > 2) then
				return 1;
			end			
		else
			GTFO.VariableStore.ArcaneLockdownStackCount = stackCount;
			if (stackCount < 3) then			
				GTFO.VariableStore.ArcaneLockdownHitCount = 1;
			end
		end
	end;
};

GTFO.SpellID["209027"] = {
  --desc = "Disrupting Energy (Guardian Construct)";
  sound = 1;
};

GTFO.SpellID["211391"] = {
  --desc = "Felblaze Puddle (Legion Hound)";
  sound = 1;
};

-- ************************
-- * Vault of the Wardens *
-- ************************

-- TODO: Tormenting Orb (Inquisitor Tormentorum)

GTFO.SpellID["202862"] = {
  --desc = "Hatred (Tirathon Saltheril)";
  sound = 1;
};

GTFO.SpellID["202919"] = {
  --desc = "Furious Flames (Tirathon Saltheril)";
  sound = 1;
};

GTFO.SpellID["194071"] = {
  --desc = "A Mother's Love (Foul Mother)";
  sound = 1;
};

GTFO.SpellID["199916"] = {
  --desc = "Shadow Crash (Faceless Voidcaster)";
  sound = 1;
};

GTFO.SpellID["194945"] = {
  --desc = "Lingering Gaze (Glazer)";
  sound = 1;
};

GTFO.SpellID["202046"] = {
  --desc = "Beam (Glazer)";
  sound = 1;
};

GTFO.SpellID["202608"] = {
  --desc = "Anguished Souls (Grimhorn the Enslaver)";
  sound = 1;
};

GTFO.SpellID["213395"] = {
  --desc = "Deepening Shadows (Cordana Felsong)";
  sound = 1;
};

-- *******************
-- * Black Rook Hold *
-- *******************

GTFO.SpellID["200344"] = {
  --desc = "Arrow Barrage (Risen Archer)";
  sound = 1;
};

GTFO.SpellID["221131"] = {
  --desc = "Arcane Overcharge (Archmage Galeorn)";
  sound = 4;
  negatingDebuffSpellID = 221132; -- Arcane Overcharge
};

GTFO.SpellID["220922"] = {
  --desc = "Overwhelming Release (Archmage Galeorn)";
  sound = 1;
};

GTFO.SpellID["197521"] = {
  --desc = "Blazing Trail (Illysanna Ravencrest)";
  sound = 1;
};

GTFO.SpellID["197821"] = {
  --desc = "Felblazed Ground (Illysanna Ravencrest)";
  sound = 1;
};

GTFO.SpellID["198501"] = {
  --desc = "Fel Vomitus (Smashspite the Hateful)";
  sound = 1;
};

GTFO.SpellID["221680"] = {
  --desc = "Fel Residue (Braxas the Fleshcarver)";
  sound = 1;
};


-- *************************
-- * The Emerald Nightmare *
-- *************************

GTFO.SpellID["221036"] = {
  --desc = "Putrid Swarm (Corrupted Vermin)";
  sound = 1;
};

GTFO.SpellID["203646"] = {
  --desc = "Burst of Corruption (Corrupted Vermin)";
  sound = 1;
};

GTFO.SpellID["220916"] = {
  --desc = "Tainted Ground";
  sound = 1;
};

GTFO.SpellID["213124"] = {
  --desc = "Venomous Pool";
  sound = 1;
};

GTFO.SpellID["215489"] = {
  --desc = "Venomous Pool";
  sound = 1;
  test = true;
};

GTFO.SpellID["212886"] = {
  --desc = "Nightmare Corruption (Il'gynoth)";
  sound = 1;
};

GTFO.SpellID["213936"] = {
  --desc = "Dark Storm (Elerethe Renferal)";
  sound = 2;
  test = true; -- may be spammy?
};

GTFO.SpellID["203045"] = {
  --desc = "Infested Ground (Nythendra)";
  sound = 1;
};

GTFO.SpellID["202978"] = {
  --desc = "Infested Breath (Nythendra)";
  sound = 1;
};

GTFO.SpellID["203097"] = {
  --desc = "Rot (Nythendra)";
  sound = 4;
  negatingBuffSpellID = 203096; -- Rot
};

GTFO.SpellID["223946"] = {
  --desc = "Dark Lightning (Guardian Rurson)";
  sound = 1;
};

GTFO.SpellID["205611"] = {
  --desc = "Miasma (Ursoc)";
  sound = 1;
};

GTFO.SpellID["212238"] = {
  --desc = "Miasma (Ursoc)";
  sound = 1;
};

GTFO.SpellID["223596"] = {
  --desc = "Darkfall (Dreadsoul Corruptor)";
  sound = 1;
};

GTFO.SpellID["203788"] = {
  --desc = "Volatile Infection (Emeriss)";
  sound = 4;
};

GTFO.SpellID["211196"] = {
  --desc = "Rotten Breath (Rotten Drake - Cenarius)";
  sound = 1;
};

GTFO.SpellID["210337"] = {
  --desc = "Nightmare Brambles (Cenarius)";
  sound = 1;
};

GTFO.SpellID["214712"] = {
  --desc = "Nightmares (Cenarius)";
  sound = 1;
};

GTFO.SpellID["211634"] = {
  --desc = "The Infinite Dark (Xavius)";
  sound = 1;
};

-- *************
-- * Nighthold *
-- *************

GTFO.SpellID["212736"] = {
  --desc = "Pool of Frost (Spellblade Aluriel)";
  sound = 1;
};

GTFO.SpellID["213504"] = {
  --desc = "Arcane Fog (Spellblade Aluriel)";
  sound = 1;
};

GTFO.SpellID["213278"] = {
  --desc = "Burning Ground (Spellblade Aluriel)";
  sound = 1;
};

GTFO.SpellID["206398"] = {
  --desc = "Fel Flame (Star Augur Etraeus)";
  sound = 1;
  applicationOnly = true;
  test = true;
};

GTFO.SpellID["219950"] = {
  --desc = "Controlled Chaos (High Botanist Tel'arn)";
  sound = 1;
  test = true;
};

GTFO.SpellID["213624"] = {
  --desc = "Mark of Frost (Spellblade Aluriel)";
  sound = 4;
  negatingBuffSpellID = 212587; -- Mark of Frost
};

GTFO.SpellID["213520"] = {
  --desc = "Arcane Orb (Spellblade Aluriel)";
  sound = 1;
  test = true;
};

GTFO.SpellID["212494"] = {
  --desc = "Annihilated (Spellblade Aluriel)";
  sound = 1;
  tankSound = 0;
};

GTFO.SpellID["216027"] = {
  --desc = "Nether Zone (Tichondrius)";
  sound = 1;
};

GTFO.SpellID["209433"] = {
  --desc = "Spanning Singularity (Grand Magistrix Elisande)";
  sound = 1;
};

GTFO.SpellID["209433"] = {
  --desc = "Spanning Singularity (Grand Magistrix Elisande)";
  sound = 1;
};

