-- -------------------------------------------------------------------------- --
-- GridConfigIcons by kunda                                                   --
-- -------------------------------------------------------------------------- --

local GridFrame = Grid:GetModule("GridFrame")
if not GridFrame then return end
local GridConfigIcons = CreateFrame("Frame")

local function SetupIcons()
	if not Grid.options then return end
	if not Grid.options.args then return end
	local GridIndicator
	if     type(Grid.options.args.GridIndicator) == "table" then GridIndicator = "GridIndicator"
	elseif type(Grid.options.args.Indicators)    == "table" then GridIndicator = "Indicators" end
	if not Grid.options.args[GridIndicator] then return end
	if not Grid.options.args[GridIndicator].args then return end

	if Grid.options.args[GridIndicator].args.corner1 then
		Grid.options.args[GridIndicator].args.corner1.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Box-Corner1"
	end
	if Grid.options.args[GridIndicator].args.corner2 then
		Grid.options.args[GridIndicator].args.corner2.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Box-Corner2"
	end
	if Grid.options.args[GridIndicator].args.corner3 then
		Grid.options.args[GridIndicator].args.corner3.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Box-Corner3"
	end
	if Grid.options.args[GridIndicator].args.corner4 then
		Grid.options.args[GridIndicator].args.corner4.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Box-Corner4"
	end

	if Grid.options.args[GridIndicator].args.border then
		Grid.options.args[GridIndicator].args.border.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Box-Border"
	end

	if Grid.options.args[GridIndicator].args.icon then
		Grid.options.args[GridIndicator].args.icon.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Icon-CenterIcon"
	end

	if Grid.options.args[GridIndicator].args.frameAlpha then
		Grid.options.args[GridIndicator].args.frameAlpha.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Box-FrameAlpha"
	end

	if Grid.options.args[GridIndicator].args.text then
		if not GridFrame.db.profile.enableText2 then
			if GridFrame.db.profile.textorientation == "VERTICAL" then
				Grid.options.args[GridIndicator].args.text.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Text-Text-center"
			else
				Grid.options.args[GridIndicator].args.text.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Text-Text-h"
			end
		else
			if GridFrame.db.profile.textorientation == "VERTICAL" then
				Grid.options.args[GridIndicator].args.text.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Text-Text-v"
			else
				Grid.options.args[GridIndicator].args.text.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Text-Text-h"
			end
		end
	end
	if Grid.options.args[GridIndicator].args.text2 then
		if GridFrame.db.profile.textorientation == "VERTICAL" then
			Grid.options.args[GridIndicator].args.text2.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Text-Text2-v"
		else
			Grid.options.args[GridIndicator].args.text2.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Text-Text2-h"
		end
	end

	if Grid.options.args[GridIndicator].args.barcolor then
		if GridFrame.db.profile.orientation == "VERTICAL" then
			Grid.options.args[GridIndicator].args.barcolor.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Box-Barcolor-v"
		else
			Grid.options.args[GridIndicator].args.barcolor.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Box-Barcolor-h"
		end
	end
	if Grid.options.args[GridIndicator].args.healingBar then
		if GridFrame.db.profile.orientation == "VERTICAL" then
			Grid.options.args[GridIndicator].args.healingBar.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Box-HealingBar-v"
		else
			Grid.options.args[GridIndicator].args.healingBar.icon = "Interface\\AddOns\\GridConfigIcons\\GridConfigIcons-icon-Box-HealingBar-h"
		end
	end
end

local function OnEvent(self, event)
	if event == "PLAYER_LOGIN" then
		SetupIcons()
		hooksecurefunc(GridFrame, "UpdateOptionsMenu", SetupIcons)
		hooksecurefunc(GridFrame, "WithAllFrames", SetupIcons)
		GridConfigIcons:UnregisterEvent("PLAYER_LOGIN")
	end
end

GridConfigIcons:RegisterEvent("PLAYER_LOGIN")
GridConfigIcons:SetScript("OnEvent", OnEvent)