--Settings:
--------------------------------------------------------------------------------------------------------------------
-- Bar width, Bar height, Fontsize and Transparency can be set ingame (Esc -> Interface -> AddOns -> PowertTrackerBar)
-- Position can be changed by typing /ptb
--------------------------------------------------------------------------------------------------------------------
PTBarSettings = {
	StatusTex = [[Interface\AddOns\PowerTrackerBar\Media\Bubble.tga]],
	PanelTex = [[Interface\AddOns\PowerTrackerBar\Media\Flat.tga]],
	font = [[Interface\AddOns\PowerTrackerBar\Media\font.ttf]],
}
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------

PowerTrackerBarSettings = PowerTrackerBarSettings or {}
PowerTrackerBar = {};
PowerTrackerBar.panel = CreateFrame( "Frame", "PowerTrackerBarPanel", UIParent );
PowerTrackerBar.panel.name = "PowerTrackerBar";
InterfaceOptions_AddCategory(PowerTrackerBar.panel);

local _, class = UnitClass("player")

--Background:
local PTBarBG = CreateFrame("Frame", "PTBarBG", UIParent)
PTBarBG:SetBackdrop({
	bgFile = PTBarSettings.PanelTex, 
	edgeFile = PTBarSettings.PanelTex, 
	tile = false, tileSize = 0, edgeSize = 1, 
	insets = { left = -1, right = -1, top = -1, bottom = -1}
})
PTBarBG:SetMovable(true)
PTBarBG:SetResizable(true)
PTBarBG:SetClampedToScreen(true)
--PTBarBG:SetUserPlaced(true)
PTBarBG:RegisterEvent("VARIABLES_LOADED")
PTBarBG:SetScript("OnEvent", function(self)
		PowerTrackerBarSettings = PowerTrackerBarSettings or {}
	
	if PowerTrackerBarSettings.PTBarBG_yOfs == nil then
		PTBarBG:SetPoint("BOTTOMLEFT", UIParent, "CENTER", -200, -50)
	else
		PTBarBG:SetPoint(PowerTrackerBarSettings.PTBarBG_point, UIParent, PowerTrackerBarSettings.PTBarBG_relativePoint, PowerTrackerBarSettings.PTBarBG_xOfs, PowerTrackerBarSettings.PTBarBG_yOfs)
	end
	
	if PowerTrackerBarSettings.SliderWidthvalue == nil then
		PTBarBG:SetWidth(181)
	else
		PTBarBG:SetWidth(PowerTrackerBarSettings.SliderWidthvalue)
	end	
	
	if PowerTrackerBarSettings.SliderHeightvalue == nil then
		PTBarBG:SetHeight(26)
	else
		PTBarBG:SetHeight(PowerTrackerBarSettings.SliderHeightvalue)
	end
	
	if PowerTrackerBarSettings.SliderTransparencyvalue == nil then
		PTBarBG:SetBackdropColor(0,0,0,.7)
		PTBarBG:SetBackdropBorderColor(.2,.2,.2,.7)
	else
		PTBarBG:SetBackdropColor(0,0,0,PowerTrackerBarSettings.SliderTransparencyvalue)
		PTBarBG:SetBackdropBorderColor(.2,.2,.2,PowerTrackerBarSettings.SliderTransparencyvalue)
	end
end)

-- Hide in PetBattle
-- Check with global PTB_displayPTB if bar should be displyed in the first place
-- PTB_displayPTB is set by the Spec settings (local SpecSettings)
PetBattleFrame:HookScript("OnShow",function()
	PTBarBG:Hide()
end)
PetBattleFrame:HookScript("OnHide",function()
	if PTB_displayPTB == true then
		PTBarBG:Show()
	end
end)

--Bar:
local TimeSinceLastUpdate = 1
local PTBar = CreateFrame("StatusBar", "PTBar", PTBarBG)
PTBar:SetStatusBarTexture(PTBarSettings.StatusTex)
PTBar:SetPoint("BOTTOMRIGHT", PTBarBG, "BOTTOMRIGHT", -2, 2)
PTBar:SetPoint("TOPLEFT", PTBarBG, "TOPLEFT", 2, -2)
PTBar:SetScript("OnUpdate", function(self, elapsed)
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
	if (TimeSinceLastUpdate >= 1) then
		self:SetMinMaxValues(0, UnitPowerMax("player"))
		self:SetValue(UnitPower("player"))
	end
end)
PTBar:RegisterEvent("ADDON_LOADED")
PTBar:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
PTBar:SetScript("OnEvent", function(self)

	PowerTrackerBarSettings = PowerTrackerBarSettings or {}
	PowerTrackerBar_PowerColor = PowerTrackerBarSettings.PowerColorvalue
	if PowerTrackerBarSettings.SliderTransparencyvalue == nil then
		PowerTrackerBar_Transparency = .7
	else
		PowerTrackerBar_Transparency = PowerTrackerBarSettings.SliderTransparencyvalue
	end
	-- old DH color http://colortohex.com/4dd827
	if PowerTrackerBarSettings.PowerColorvalue == nil then
		local r, g, b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
	elseif PowerTrackerBarSettings.PowerColorvalue == false then
		local r, g, b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
	elseif PowerTrackerBarSettings.PowerColorvalue == true then
		local powerType, powerToken, altR, altG, altB = UnitPowerType("player");
		local info = PowerBarColor[powerToken];
		if class ~= "DEMONHUNTER" then
			if ( info ) then --The PowerBarColor takes priority			
				r, g, b = info.r, info.g, info.b;
			else
				if ( not altR) then
					-- Couldn't find a power token entry. Default to indexing by power type or just mana if we don't have that either.
					info = PowerBarColor[powerType] or PowerBarColor["MANA"];
					r, g, b = info.r, info.g, info.b;
				else
					r, g, b = altR, altG, altB;
				end
			end
		else
		r, g, b = 0/255, 210/255, 49/255;
		end
		
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
	end
	
	if PowerTrackerBarSettings.SliderFontsizevalue == nil then
		PowerTrackerBar_StatusText:SetFont(PTBarSettings.font, 16, "THINOUTLINE")
	else
		PowerTrackerBar_StatusText:SetFont(PTBarSettings.font, PowerTrackerBarSettings.SliderFontsizevalue, "THINOUTLINE")
	end
end)



--Text:
local PTBar_StatusText = CreateFrame("StatusBar", "PTBar_StatusText", PTBarBG)
PowerTrackerBar_StatusText = PTBar_StatusText:CreateFontString(nil, "OVERLAY")
PowerTrackerBar_StatusText:SetPoint("CENTER", PTBarBG, "CENTER")

if class == "MONK" then
	local function MONK_TEXT()
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 12)
		local spec = GetSpecialization() -- 1 = BrM; 2 = MW; 3 = WW
		if spec == 3 then 
			PowerTrackerBar_StatusText:SetText(Power .. ' - ' .. altpower)
		else
			PowerTrackerBar_StatusText:SetText(Power)
		end
	end
	PTBar_StatusText:SetScript("OnEvent", MONK_TEXT)
	PTBar_StatusText:RegisterEvent("UNIT_POWER")
	PTBar_StatusText:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar_StatusText:RegisterEvent("PLAYER_ENTERING_WORLD")
	
elseif class == "ROGUE" then
	local function ROGUE_TEXT()
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 4)
		PowerTrackerBar_StatusText:SetText(Power .. ' - ' .. altpower)
	end

	PTBar_StatusText:SetScript("OnEvent", ROGUE_TEXT)
	PTBar_StatusText:RegisterEvent("UNIT_POWER")
	PTBar_StatusText:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar_StatusText:RegisterEvent("PLAYER_ENTERING_WORLD")
	
elseif class == "DRUID" then
	local function DRUID_TEXT()
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 4)
		local ShapeshiftForm = GetShapeshiftForm()
		local spec = GetSpecialization() -- 1 = Moonkin; 2 = Feral; 3 = tank; 4 = restro
		if spec == 2 then 		
			if ShapeshiftForm == 2 or altpower >= 1 then
				PowerTrackerBar_StatusText:SetText(Power .. ' - ' .. altpower)
			else
				PowerTrackerBar_StatusText:SetText(Power)
			end
		elseif spec == 1 then
			
			local PlayerCast = UnitCastingInfo("player")
			
			-- Astral Power Numbers:
			---------------------------------------
			local base_LS = 12
			local base_SR = 8
			
			local newmoon = 10
			local halfmoon = 20
			local fullmoon = 40
			
			local CA_multiplier = 1.5
			local blessing_multiplier = 1.25
			---------------------------------------
			
			local blessing = UnitBuff("player", GetSpellInfo(202737))
			local CelAli = UnitBuff("player", GetSpellInfo(194223))
			local incar = UnitBuff("player", GetSpellInfo(102560))

		
			if PlayerCast == "Lunar Strike" or PlayerCast == "Solar Wrath" or PlayerCast == "New Moon" or PlayerCast == "Half Moon" or PlayerCast == "Full Moon" then
				if PlayerCast == "Lunar Strike" then
					if blessing == "Blessing of Elune" and (CelAli == "Celestial Alignment" or incar == "Incarnation: Chosen of Elune") then 
						PowerTrackerBar_StatusText:SetText(Power .. ' (' .. floor(Power+base_LS*blessing_multiplier*CA_multiplier) .. ')') -- blizzard rounds down
					elseif CelAli == "Celestial Alignment" or incar == "Incarnation: Chosen of Elune" then
						PowerTrackerBar_StatusText:SetText(Power .. ' (' .. Power+base_LS*CA_multiplier .. ')')
					elseif blessing == "Blessing of Elune" then
						PowerTrackerBar_StatusText:SetText(Power .. ' (' .. Power+base_LS*blessing_multiplier .. ')')
					else
						PowerTrackerBar_StatusText:SetText(Power .. ' (' .. Power+base_LS .. ')')
					end
				elseif PlayerCast == "Solar Wrath" then
					if blessing == "Blessing of Elune" and (CelAli == "Celestial Alignment" or incar == "Incarnation: Chosen of Elune") then 
						PowerTrackerBar_StatusText:SetText(Power .. ' (' .. Power+base_SR*blessing_multiplier*CA_multiplier .. ')')
					elseif CelAli == "Celestial Alignment" or incar == "Incarnation: Chosen of Elune" then
						PowerTrackerBar_StatusText:SetText(Power .. ' (' .. Power+base_SR*CA_multiplier .. ')')
					elseif blessing == "Blessing of Elune" then
						PowerTrackerBar_StatusText:SetText(Power .. ' (' .. Power+base_SR*blessing_multiplier .. ')')
					else
						PowerTrackerBar_StatusText:SetText(Power .. ' (' .. Power+base_SR .. ')')
					end
				elseif PlayerCast == "New Moon" then
					PowerTrackerBar_StatusText:SetText(Power .. ' (' .. Power+newmoon .. ')')
				elseif PlayerCast == "Half Moon" then
					PowerTrackerBar_StatusText:SetText(Power .. ' (' .. Power+halfmoon .. ')')
				elseif PlayerCast == "Full Moon" then
					PowerTrackerBar_StatusText:SetText(Power .. ' (' .. Power+fullmoon .. ')')
				end
			else
			PowerTrackerBar_StatusText:SetText(Power)
			end
			
		else
			PowerTrackerBar_StatusText:SetText(Power)
		end
	end
	PTBar_StatusText:SetScript("OnEvent", DRUID_TEXT)
	PTBar_StatusText:RegisterEvent("UNIT_POWER")
	PTBar_StatusText:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar_StatusText:RegisterEvent("PLAYER_ENTERING_WORLD")
	PTBar_StatusText:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
	PTBar_StatusText:RegisterEvent("UNIT_SPELLCAST_START")
	PTBar_StatusText:RegisterEvent("UNIT_SPELLCAST_SUCCESS")
	PTBar_StatusText:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
	PTBar_StatusText:RegisterEvent("UNIT_AURA")
	
elseif class == "PALADIN" then
	local function PALADIN_TEXT()
		local Power = (UnitPower("player"))
		local altpower = UnitPower("player", 9)
		PowerTrackerBar_StatusText:SetText(Power .. ' - ' .. altpower)
	end
	PTBar_StatusText:SetScript("OnEvent", PALADIN_TEXT)
	PTBar_StatusText:RegisterEvent("UNIT_POWER")
	PTBar_StatusText:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar_StatusText:RegisterEvent("PLAYER_ENTERING_WORLD")
	
else
	local function else_TEXT()
		local Power = (UnitPower("player"))
		PowerTrackerBar_StatusText:SetText(Power)
	end
	PTBar_StatusText:SetScript("OnEvent", else_TEXT)
	PTBar_StatusText:RegisterEvent("UNIT_POWER")
	PTBar_StatusText:RegisterEvent("UNIT_POWER_FREQUENT")
	PTBar_StatusText:RegisterEvent("PLAYER_ENTERING_WORLD")
end