local _, class = UnitClass("player")

-- Settingstext Headline (PowerTrackerBar Settings:)
local Settingstext = PowerTrackerBar.panel:CreateFontString("Settingstext")
Settingstext:SetFontObject('GameFontNormalLarge')
Settingstext:SetPoint("TOPLEFT", 5,-5)
Settingstext:SetText('PowerTrackerBar Settings:')

-- Settingstext2 Small (Type /ptb to unlock)
local Settingstext2 = PowerTrackerBar.panel:CreateFontString("Settingstext2")
Settingstext2:SetFontObject('GameFontNormalSmall')
Settingstext2:SetPoint("TOPLEFT", 5,-30)
Settingstext2:SetText('Type /ptb to unlock')

-- Slider for Width
local SliderWidth = CreateFrame("Slider","PowerTrackerBarSliderWidth",PowerTrackerBar.panel,'OptionsSliderTemplate') 
local EditBoxWidth = CreateFrame("EditBox","PowerTrackerBarEditBoxWidth",SliderWidth,'InputBoxTemplate')
local OkButtonWidth = CreateFrame("Button","PowerTrackerBarButtonToGolbal",EditBoxWidth,'UIPanelButtonTemplate')
local SliderWidthMaxValue = 500 -- dynamic slider
EditBoxWidth:SetPoint("Right",60,0)
EditBoxWidth:SetWidth(40)
EditBoxWidth:SetHeight(20)
EditBoxWidth:SetAutoFocus(false)
SliderWidth:SetPoint("TOPLEFT",40,-70)
_G[SliderWidth:GetName() .. 'Low']:SetText('1');
_G[SliderWidth:GetName() .. 'High']:SetText(SliderWidthMaxValue);
SliderWidth:SetMinMaxValues(1, SliderWidthMaxValue)
SliderWidth:SetValueStep(1)
SliderWidth:SetWidth(250)
-- Save the Width in the SavedVariables and set the Width ingame
SliderWidth:SetScript("OnValueChanged", function(self)
	local value = ceil(self:GetValue())
	
	PowerTrackerBarSettings.SliderWidthvalue = value
	
	PTBarBG:SetWidth(value)
	EditBoxWidth:SetText(value)
	_G[SliderWidth:GetName() .. 'Text']:SetText('Bar Width: '.. ceil(SliderWidth:GetValue()));
end)

OkButtonWidth:SetPoint("Right",40,0)
OkButtonWidth:SetText("OK")
OkButtonWidth:SetScript("OnClick", function(self)

	local value = ceil(EditBoxWidth:GetText())
	
	PowerTrackerBarSettings.SliderWidthvalue = value
	
	PTBarBG:SetWidth(value)
	SliderWidth:SetValue(value)
end
);


--Slider and editbox for Height
local SliderHeight = CreateFrame("Slider","PowerTrackerBarSliderHeight",PowerTrackerBar.panel,'OptionsSliderTemplate')
local EditBoxHeight = CreateFrame("EditBox","PowerTrackerBarEditBoxWidth",SliderHeight,'InputBoxTemplate')
local OkButtonHeight = CreateFrame("Button","PowerTrackerBarButtonToGolbal",EditBoxHeight,'UIPanelButtonTemplate')
EditBoxHeight:SetPoint("Right",60,0)
EditBoxHeight:SetWidth(40)
EditBoxHeight:SetHeight(20)
EditBoxHeight:SetAutoFocus(false)
SliderHeight:SetPoint("TOPLEFT",40,-125)
_G[SliderHeight:GetName() .. 'Low']:SetText('1');
_G[SliderHeight:GetName() .. 'High']:SetText('100');
SliderHeight:SetMinMaxValues(1, 100)
SliderHeight:SetValueStep(1)
SliderHeight:SetWidth(250)
-- Save the Height in the SavedVariables and set the Height ingame
SliderHeight:SetScript("OnValueChanged", function(self)
	local value = ceil(self:GetValue())
	
	PowerTrackerBarSettings.SliderHeightvalue = value
	
	PTBarBG:SetHeight(value)
	EditBoxHeight:SetText(value)
	_G[SliderHeight:GetName() .. 'Text']:SetText('Bar Height: '.. ceil(SliderHeight:GetValue()));
end)

OkButtonHeight:SetPoint("Right",40,0)
OkButtonHeight:SetText("OK")
OkButtonHeight:SetScript("OnClick", function(self)

	local value = ceil(EditBoxHeight:GetText())
	
	PowerTrackerBarSettings.SliderHeightvalue = value
	
	PTBarBG:SetHeight(value)
	SliderHeight:SetValue(value)
end
);


-- Slider for Transparency (opacity)
local SliderTransparency = CreateFrame("Slider","PowerTrackerBarSliderTransparency",PowerTrackerBar.panel,'OptionsSliderTemplate') 
SliderTransparency:SetPoint("TOPLEFT",40,-180)
_G[SliderTransparency:GetName() .. 'Low']:SetText('0%');
_G[SliderTransparency:GetName() .. 'High']:SetText('100%');
SliderTransparency:SetMinMaxValues(0, 1)
SliderTransparency:SetValueStep(.01)
SliderTransparency:SetWidth(250)
--Save the Transparency in the SavedVariables and set the Transparency ingame (ingame Silder name: Opacity)
SliderTransparency:SetScript("OnValueChanged", function(self)
	local value_ = self:GetValue()
	local value = (ceil(value_*100))/100
	
	PowerTrackerBar_Transparency = value	
	PowerTrackerBarSettings.SliderTransparencyvalue = value
	
	PTBarBG:SetBackdropColor(0,0,0,value)
	PTBarBG:SetBackdropBorderColor(.2,.2,.2,value)
	
	if PowerTrackerBar_PowerColor == false or PowerTrackerBar_PowerColor == nil then
		local r, g, b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
	elseif PowerTrackerBar_PowerColor == true then
		local powerType, powerToken, altR, altG, altB = UnitPowerType("player");
		local info = PowerBarColor[powerToken];	
		if class ~= "DEMONHUNTER" then
			if ( info ) then --The PowerBarColor takes priority			
				r, g, b = info.r, info.g, info.b;
			else
				if ( not altR) then
					-- Couldn't find a power token entry. Default to indexing by power type or just mana if we don't have that either.
					info = PowerBarColor[powerType] or PowerBarColor["MANA"];
					r, g, b = info.r, info.g, info.b;
				else
					r, g, b = altR, altG, altB;
				end
			end
		else
		r, g, b = 0/255, 210/255, 49/255;
		end
		
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
	end	
	
	_G[SliderTransparency:GetName() .. 'Text']:SetText('Opacity: '.. ceil(SliderTransparency:GetValue()*100)..'%');
end)


-- Slider for Fontsize
local SliderFontsize = CreateFrame("Slider","PowerTrackerBarSliderFontsize",PowerTrackerBar.panel,'OptionsSliderTemplate') 
SliderFontsize:SetPoint("TOPLEFT",40,-235)
_G[SliderFontsize:GetName() .. 'Low']:SetText('10');
_G[SliderFontsize:GetName() .. 'High']:SetText('35');
SliderFontsize:SetMinMaxValues(10, 35)
SliderFontsize:SetValueStep(1)
SliderFontsize:SetWidth(250)
-- Save the Fontsize in the SavedVariables and set the Fontsize ingame
SliderFontsize:SetScript("OnValueChanged", function(self)
	local value = ceil(self:GetValue())
	
	PowerTrackerBarSettings.SliderFontsizevalue = value
	
	PowerTrackerBar_StatusText:SetFont(PTBarSettings.font, value, "THINOUTLINE")
	_G[SliderFontsize:GetName() .. 'Text']:SetText('Fontsize: '.. ceil(SliderFontsize:GetValue()));
end)


-- Option to hide the Bar out of combat
local HideOOCtext = PowerTrackerBar.panel:CreateFontString("text")
HideOOCtext:SetFontObject('GameFontNormalSmall')
HideOOCtext:SetPoint("TOPLEFT", 70,-305, "CENTER")
HideOOCtext:SetText('Only show in combat')
PTB_HideOOC = CreateFrame("CheckButton", "PowerTrackerBarHideOOC", PowerTrackerBar.panel, "ChatConfigCheckButtonTemplate");
PTB_HideOOC:SetPoint("TOPLEFT", 40, -300, "CENTER");
PTB_HideOOC.tooltip = "Show the PowerTrackerBar only in combat";
-- Save option in the SavedVariables and apply ingame
-- Check with global PTB_displayPTB if bar should be displyed in the first place
-- PTB_displayPTB is set by the Spec settings (local SpecSettings)
PTB_HideOOC:SetScript("OnClick", function(self)
	local state = self:GetChecked()
	PowerTrackerBarSettings.HideOOCvalue = state
	
	if self:GetChecked() == true then
		PTBarBG:Hide()
		local PTBar_hide = CreateFrame("Frame")
		local function HideOrShow(self, event, ...)
			if event == "PLAYER_REGEN_DISABLED" and PTB_displayPTB == true then
				PTBarBG:Show()				
			elseif event == "PLAYER_REGEN_ENABLED" then
				PTBarBG:Hide()
			end
		end
		PTBar_hide:SetScript("OnEvent",HideOrShow)
		PTBar_hide:RegisterEvent("PLAYER_REGEN_DISABLED")
		PTBar_hide:RegisterEvent("PLAYER_REGEN_ENABLED")
	elseif self:GetChecked() == false and PTB_displayPTB == true then
		PTBarBG:Show()
		local PTBar_hide = CreateFrame("Frame")
		local function HideOrShow(self, event, ...)
			if event == "PLAYER_REGEN_DISABLED" and PTB_displayPTB == true then
				PTBarBG:Show()
				
			elseif event == "PLAYER_REGEN_ENABLED" and PTB_displayPTB == true then
				PTBarBG:Show()
			end
		end
		PTBar_hide:SetScript("OnEvent",HideOrShow)
		PTBar_hide:RegisterEvent("PLAYER_REGEN_DISABLED")
		PTBar_hide:RegisterEvent("PLAYER_REGEN_ENABLED")
	end
end
);

-- Load the value from the SavedVariables, set the checkbox and apply ingame
PTB_HideOOC:RegisterEvent("ADDON_LOADED")
PTB_HideOOC:SetScript("OnEvent", function(self)
	PowerTrackerBarSettings = PowerTrackerBarSettings or {}
	
	if PowerTrackerBarSettings.HideOOCvalue == nil then
		PTB_HideOOC:SetChecked(false)
	elseif PowerTrackerBarSettings.HideOOCvalue == true then
		PTB_HideOOC:SetChecked(PowerTrackerBarSettings.HideOOCvalue)
		PTBarBG:Hide()
		local PTBar_hide = CreateFrame("Frame")
		local function HideOrShow(self, event, ...)
			if event == "PLAYER_REGEN_DISABLED" and PTB_displayPTB == true then
				PTBarBG:Show()
				
			elseif event == "PLAYER_REGEN_ENABLED" then
				PTBarBG:Hide()
			end
		end
		PTBar_hide:SetScript("OnEvent",HideOrShow)
		PTBar_hide:RegisterEvent("PLAYER_REGEN_DISABLED")
		PTBar_hide:RegisterEvent("PLAYER_REGEN_ENABLED")
		
	else PTB_HideOOC:SetChecked(PowerTrackerBarSettings.HideOOCvalue)		
	end
end)


-- PowerColor
local PowerColorText = PowerTrackerBar.panel:CreateFontString("text")
PowerColorText:SetFontObject('GameFontNormalSmall')
PowerColorText:SetPoint("TOPLEFT", 70,-325, "CENTER")
if class ~= "DEMONHUNTER" then -- DH don't need an option to switch Class color with power color
	PowerColorText:SetText('Use power type color instead of class color')
else
	PowerColorText:SetText('Use the Legion-Alpha Demon Hunter class color (Fel-green)')
end
local PowerColor = CreateFrame("CheckButton", "PowerTrackerBarPowerColor", PowerTrackerBar.panel, "ChatConfigCheckButtonTemplate");
PowerColor:SetPoint("TOPLEFT", 40, -320, "CENTER");
if class ~= "DEMONHUNTER" then
	PowerColor.tooltip = "E.g. red in bear form & yellow in cat form instead of orange.";
else
	PowerColor.tooltip = "'Dark lila' is just utterly ugly";
end

-- Save option in the SavedVariables and set the Fontsize ingame and apply ingame
PowerColor:SetScript("OnClick", function(self)
	local state = self:GetChecked()
	PowerTrackerBarSettings.PowerColorvalue = state
	PowerTrackerBar_PowerColor = state
	
	if self:GetChecked() == true then
		local powerType, powerToken, altR, altG, altB = UnitPowerType("player");
		local info = PowerBarColor[powerToken];
		
		if class ~= "DEMONHUNTER" then
			if ( info ) then
				--The PowerBarColor takes priority
				r, g, b = info.r, info.g, info.b;
			else
				if ( not altR) then
					-- Couldn't find a power token entry. Default to indexing by power type or just mana if we don't have that either.
					info = PowerBarColor[powerType] or PowerBarColor["MANA"];
					r, g, b = info.r, info.g, info.b;
				else
					r, g, b = altR, altG, altB;
				end
			end
		else
		r, g, b = 0/255, 210/255, 49/255; -- Alpha DH colors
		end
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
	elseif self:GetChecked() == false then
		local _, class = UnitClass("player")
		local r,g,b = RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
		PTBar:SetStatusBarColor(r,g,b,PowerTrackerBar_Transparency)
	end
end)

-- Load the value from the SavedVariables, set the checkbox and apply ingame
PowerColor:RegisterEvent("ADDON_LOADED")
PowerColor:SetScript("OnEvent", function(self)
	PowerTrackerBarSettings = PowerTrackerBarSettings or {}
	
	if PowerTrackerBarSettings.PowerColorvalue == nil then
		PowerColor:SetChecked(false)
	elseif PowerTrackerBarSettings.PowerColorvalue == false then
		PowerColor:SetChecked(false)
	elseif PowerTrackerBarSettings.PowerColorvalue == true then
		PowerColor:SetChecked(true)
	end	
end)

-- SpecSettings Small (Choose Spec)
local SpecSettings = PowerTrackerBar.panel:CreateFontString("SpecSettings")
SpecSettings:SetFontObject('GameFontNormalSmall')
SpecSettings:SetPoint("TOPLEFT", 40,-355)
SpecSettings:SetText('Display as:')


-- Checkbox Spec 1
local PTB_Spec1text = PowerTrackerBar.panel:CreateFontString("text")
PTB_Spec1text:SetFontObject('GameFontNormalSmall')
PTB_Spec1text:SetPoint("TOPLEFT", 70,-375, "CENTER")

PTB_Spec1 = CreateFrame("CheckButton", "PowerTrackerBarPTB_PTB_Spec1", PowerTrackerBar.panel, "ChatConfigCheckButtonTemplate");
PTB_Spec1:SetPoint("TOPLEFT", 40, -370, "CENTER");

PTB_Spec1:SetScript("OnClick", function(self)
	local state = self:GetChecked()
	PowerTrackerBarSettings.PTB_Spec1value = state
	
	if self:GetChecked() == true and GetSpecialization() == 1 then
		if PTB_HideOOC:GetChecked() == false then 
			PTBarBG:Show()
		end
		PTB_displayPTB = true
	elseif self:GetChecked() == false and GetSpecialization() == 1 then
		PTBarBG:Hide()
		PTB_displayPTB = false
	end
end
);

PTB_Spec1:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
PTB_Spec1:RegisterEvent("ADDON_LOADED")
PTB_Spec1:SetScript("OnEvent", function(self)
	_, _PTB_Spec1text = GetSpecializationInfo(1)
	PTB_Spec1text:SetText(_PTB_Spec1text)

	PowerTrackerBarSettings = PowerTrackerBarSettings or {}
	
	if PowerTrackerBarSettings.PTB_Spec1value == nil or PowerTrackerBarSettings.PTB_Spec1value == true then
		PTB_Spec1:SetChecked(true)
	elseif PowerTrackerBarSettings.PTB_Spec1value == false then
		PTB_Spec1:SetChecked(false)
		if GetSpecialization() == 1 then
			PTBarBG:Hide()
		end
	end
end)


-- Checkbox Spec 2
local PTB_Spec2text = PowerTrackerBar.panel:CreateFontString("text")
PTB_Spec2text:SetFontObject('GameFontNormalSmall')
PTB_Spec2text:SetPoint("TOPLEFT", 70,-395, "CENTER")

PTB_Spec2 = CreateFrame("CheckButton", "PowerTrackerBarPTB_Spec2", PowerTrackerBar.panel, "ChatConfigCheckButtonTemplate");
PTB_Spec2:SetPoint("TOPLEFT", 40, -390, "CENTER");

PTB_Spec2:SetScript("OnClick", function(self)
	local state = self:GetChecked()
	PowerTrackerBarSettings.PTB_Spec2value = state
	
	if self:GetChecked() == true and GetSpecialization() == 2 then
		if PTB_HideOOC:GetChecked() == false then 
			PTBarBG:Show()
		end
		PTB_displayPTB = true
	elseif self:GetChecked() == false and GetSpecialization() == 2 then
		PTBarBG:Hide()
		PTB_displayPTB = false
	end
end
);

PTB_Spec2:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
PTB_Spec2:RegisterEvent("ADDON_LOADED")
PTB_Spec2:SetScript("OnEvent", function(self)
	_, _PTB_Spec2text = GetSpecializationInfo(2)
	PTB_Spec2text:SetText(_PTB_Spec2text)

	PowerTrackerBarSettings = PowerTrackerBarSettings or {}
	
	if PowerTrackerBarSettings.PTB_Spec2value == nil or PowerTrackerBarSettings.PTB_Spec2value == true then
		PTB_Spec2:SetChecked(true)
	elseif PowerTrackerBarSettings.PTB_Spec2value == false then
		PTB_Spec2:SetChecked(false)
		if GetSpecialization() == 2 then
			PTBarBG:Hide()
		end
	end
end)


-- Checkbox Spec 3 for everyone except DH
if class ~= "DEMONHUNTER" then

local PTB_Spec3text = PowerTrackerBar.panel:CreateFontString("text")
PTB_Spec3text:SetFontObject('GameFontNormalSmall')
PTB_Spec3text:SetPoint("TOPLEFT", 70,-415, "CENTER")

PTB_Spec3 = CreateFrame("CheckButton", "PowerTrackerBarPTB_Spec3", PowerTrackerBar.panel, "ChatConfigCheckButtonTemplate");
PTB_Spec3:SetPoint("TOPLEFT", 40, -410, "CENTER");

PTB_Spec3:SetScript("OnClick", function(self)
	local state = self:GetChecked()
	PowerTrackerBarSettings.PTB_Spec3value = state
	
	if self:GetChecked() == true and GetSpecialization() == 3 then
		if PTB_HideOOC:GetChecked() == false then 
			PTBarBG:Show()
		end
		PTB_displayPTB = true
	elseif self:GetChecked() == false and GetSpecialization() == 3 then
		PTBarBG:Hide()
		PTB_displayPTB = false
	end
end
);

PTB_Spec3:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
PTB_Spec3:RegisterEvent("ADDON_LOADED")
PTB_Spec3:SetScript("OnEvent", function(self)
	_, _PTB_Spec3text = GetSpecializationInfo(3)
	PTB_Spec3text:SetText(_PTB_Spec3text)

	PowerTrackerBarSettings = PowerTrackerBarSettings or {}
	
	if PowerTrackerBarSettings.PTB_Spec3value == nil or PowerTrackerBarSettings.PTB_Spec3value == true then
		PTB_Spec3:SetChecked(true)
	elseif PowerTrackerBarSettings.PTB_Spec3value == false then
		PTB_Spec3:SetChecked(false)
		if GetSpecialization() == 3 then
			PTBarBG:Hide()
		end
	end
end)

end


-- Checkbox Spec 4 for druids only
if class == "DRUID" then

local PTB_Spec4text = PowerTrackerBar.panel:CreateFontString("text")
PTB_Spec4text:SetFontObject('GameFontNormalSmall')
PTB_Spec4text:SetPoint("TOPLEFT", 70,-435, "CENTER")

PTB_Spec4 = CreateFrame("CheckButton", "PowerTrackerBarPTB_Spec4", PowerTrackerBar.panel, "ChatConfigCheckButtonTemplate");
PTB_Spec4:SetPoint("TOPLEFT", 40, -430, "CENTER");

PTB_Spec4:SetScript("OnClick", function(self)
	local state = self:GetChecked()
	PowerTrackerBarSettings.PTB_Spec4value = state
	
	if self:GetChecked() == true and GetSpecialization() == 4 then
		if PTB_HideOOC:GetChecked() == false then 
			PTBarBG:Show()
		end
		PTB_displayPTB = true
	elseif self:GetChecked() == false and GetSpecialization() == 4 then
		PTBarBG:Hide()
		PTB_displayPTB = false
	end
end
);

PTB_Spec4:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
PTB_Spec4:RegisterEvent("ADDON_LOADED")
PTB_Spec4:SetScript("OnEvent", function(self)
	_, _PTB_Spec4text = GetSpecializationInfo(4)
	PTB_Spec4text:SetText(_PTB_Spec4text)

	PowerTrackerBarSettings = PowerTrackerBarSettings or {}
	
	if PowerTrackerBarSettings.PTB_Spec4value == nil or PowerTrackerBarSettings.PTB_Spec4value == true then
		PTB_Spec4:SetChecked(true)
	elseif PowerTrackerBarSettings.PTB_Spec4value == false then
		PTB_Spec4:SetChecked(false)
		if GetSpecialization() == 4 then
			PTBarBG:Hide()
		end
	end
end)

end

-- Set the global PTB_displayPTB
local SpecSettings = CreateFrame("Frame",nil,UIParent)
SpecSettings:RegisterEvent("ACTIONBAR_SLOT_CHANGED")
SpecSettings:RegisterEvent("ADDON_LOADED")
SpecSettings:SetScript("OnEvent", function(self)
	if
	(GetSpecialization() == 1 and PTB_Spec1:GetChecked() == true) or
	(GetSpecialization() == 2 and PTB_Spec2:GetChecked() == true) or
	(GetSpecialization() == 3 and PTB_Spec3:GetChecked() == true) or
	(GetSpecialization() == 4 and PTB_Spec4:GetChecked() == true) then
		PTB_displayPTB = true
	else	
		PTB_displayPTB = false
	end
end)


-- Set the Silder to the SavedVariables values, if SavedVariables == nil set to default
PowerTrackerBar.panel.refresh = function()

	if PowerTrackerBarSettings.SliderWidthvalue == nil then
		SliderWidth:SetValue(181)
	elseif
		PowerTrackerBarSettings.SliderWidthvalue >= 501 then -- do nothing so the slider max value (500) doesn't override it
	else
		SliderWidth:SetValue(PowerTrackerBarSettings.SliderWidthvalue)
	end
	
	if PowerTrackerBarSettings.SliderHeightvalue == nil then
		SliderHeight:SetValue(26)
	elseif
		PowerTrackerBarSettings.SliderHeightvalue >= 101 then -- do nothing so the slider max value (100) doesn't override it
	else
		SliderHeight:SetValue(PowerTrackerBarSettings.SliderHeightvalue)
	end
	
	if PowerTrackerBarSettings.SliderTransparencyvalue == nil then
		SliderTransparency:SetValue(.7)
	else
		SliderTransparency:SetValue(PowerTrackerBarSettings.SliderTransparencyvalue)
	end
	
	if PowerTrackerBarSettings.SliderFontsizevalue == nil then
		SliderFontsize:SetValue(16)
	else
		SliderFontsize:SetValue(PowerTrackerBarSettings.SliderFontsizevalue)
	end

end


-- Create Resize frame in the bottom right corner
local resizeButton = CreateFrame("Button", nil, PTBarBG)
resizeButton:SetSize(16, 16)
resizeButton:SetPoint("CENTER", PTBar, "BOTTOMRIGHT")
resizeButton:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
resizeButton:SetHighlightTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
resizeButton:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")
--hide it in default state
resizeButton:RegisterEvent("PLAYER_ENTERING_WORLD")
resizeButton:SetScript("OnEvent", function(self)
	self:Hide()
end)

--slash command (drag to move or hold lower right corner to resize)
local PTBmove = false 
local function POWER()
	if not PTBmove then
		-- Resize:
		resizeButton:Show()
		resizeButton:SetScript("OnMouseDown", function(self, button) 	-- allows resizing of the frame while clicking on the Resize frame
			PTBarBG:StartSizing("BOTTOMRIGHT")
			PTBarBG:SetUserPlaced(true)
		end)
		resizeButton:SetScript("OnMouseUp", function(self, button)
			PTBarBG:StopMovingOrSizing()
		end)
		-- Drag:
		PTBarBG:RegisterForDrag("LeftButton")
		PTBarBG:SetScript("OnDragStart", PTBarBG.StartMoving)
		PTBarBG:SetScript("OnDragStop", PTBarBG.StopMovingOrSizing)
		
		print("PowerTrackerBar unlocked, type /ptb to save. Bar width, Bar height, Fontsize and Opacity can be set in the option menu (Esc -> Interface -> AddOns -> PowertTrackerBar)")
		PTBmove = true
		PTBarBG:EnableMouse(true)
	elseif PTBmove == true then
		resizeButton:Hide()
		if PTBarBG:GetWidth() <= 0 then PTBarBG:SetWidth(5) end
		if PTBarBG:GetHeight() <= 0 then PTBarBG:SetHeight(5) end
		PowerTrackerBarSettings.SliderWidthvalue = PTBarBG:GetWidth() -- save new width/height in SavedVariables
		PowerTrackerBarSettings.SliderHeightvalue = PTBarBG:GetHeight() -- save new width/height in SavedVariables
		PowerTrackerBarSettings.PTBarBG_point = select(1,PTBarBG:GetPoint())
		PowerTrackerBarSettings.PTBarBG_relativeTo = select(2,PTBarBG:GetPoint())
		PowerTrackerBarSettings.PTBarBG_relativePoint = select(3,PTBarBG:GetPoint())
		PowerTrackerBarSettings.PTBarBG_xOfs = select(4,PTBarBG:GetPoint())
		PowerTrackerBarSettings.PTBarBG_yOfs = select(5,PTBarBG:GetPoint())
		PTBarBG:EnableMouse(false)
		PTBmove = false
		print("PowerTrackerBar locked")
	end
end
SLASH_POWER1 = "/PTB"
SlashCmdList["POWER"] = POWER